//(c) Denis Nelubin aka Gelin, 2004-2006
//Simpliest screen saver - Ascetic Clock
//v.0.0.6 - setup window added
//v.0.0.5 - trying to fix another bug with resource limitation (?) in win9x
//v.0.0.4 - trying to fix bug with double buffer in win9x
//v.0.0.3 - one quality parameter
//v.0.0.2 - screen saver 
//v.0.0.1 - smooth, not smooth
//v.0.0.0 - just clock

#include <windows.h>
#include <mem.h>
#include <math.h>
#include <commctrl.h>
#include <stdio.h>

#define MAINCLASS "ClockClass"
#define CONFCLASS "ClockConfClass"

#define CLKRADIUS 0.95
#define HOURRADIUS 0.6
#define MINRADIUS 1.0
#define SECRADIUS 1.0
#define MARKRADIUS1 0.6
#define MARKRADIUS2 0.7
#define BOLDPEN 0.06
#define MEDIUMPEN 0.03
#define THINPEN 0.005

#define ID_TRACKBAR 0
#define ID_BUTT 1
#define TRACKWIDTH 220
#define TRACKHEIGHT 30
#define BORDWIDTH 2
#define TITLEHEIGHT 22
#define TEXTHEIGHT 17
#define BUTTHEIGHT 21
#define BUTTWIDTH 40

//each level contains {update_interval, dbl_buffer, antialiasing}
int qual[][3] =
{{1000,0,0},
 {500,0,0},
 {250,0,0},
 {100,1,0},
 {50,1,0},
 {50,1,1}};

//quality level
int Q = 3;
int upd_int = qual[Q][0];
int dbl_buf = qual[Q][1];
int antial = qual[Q][2];

LRESULT CALLBACK WinProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void Paint(HWND hwnd);
void DrawClock(HDC hdc, int x, int y, int radius);
void RunFullScreen();
HWND CreateScreenSaverWindow(int width, int height, HWND Parent);
void parsecommand();
void Configure();
LRESULT CALLBACK ConfProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam);
void GetQual(int);
void SaveQual();
void LoadQual();

int width, height;
HWND hwnd;
HINSTANCE hInst;

int resized = 1;

int targc=0;
char* targv[30];
int preview=0;

int WINAPI WinMain(HINSTANCE Inst, HINSTANCE hPrevInst,
                   LPSTR lpCmdLine, int nCmdShow)
{
 
 HWND hwnd;
 MSG msg;       //one message
 RECT rect;
 unsigned long dummy;

 hInst = Inst;

 parsecommand();
 LoadQual();

 if(targc>=2)
  switch(targv[1][1])
  {
   case 'p': case 'P':
    if(targc>=3)
    {
     preview = 1;
     hwnd = (HWND)atoi(targv[2]);
     GetWindowRect(hwnd,&rect);
     width=rect.right-rect.left;
     height=rect.bottom-rect.top;
     hwnd = CreateScreenSaverWindow(width, height, hwnd);
    }
   break;
   case 'c': case 'C':
    Configure();
    //MessageBox(NULL, "Nothing to configure.", "Gelin's clock.scr", MB_OK|MB_ICONINFORMATION);
    exit(0);
  }

 if(!preview)
 {
  GetWindowRect(GetDesktopWindow(),&rect);
  width = rect.right-rect.left;
  height = rect.bottom-rect.top;
  hwnd = CreateScreenSaverWindow(width, height, 0);
  ShowCursor(0);
  SystemParametersInfo(SPI_SCREENSAVERRUNNING,1,&dummy,0);
 }

 //set and init timer
 if(!SetTimer(hwnd, 1, upd_int, NULL))
 {
  MessageBox(NULL, "Can't set timer!", "Error!", MB_OK|MB_ICONERROR);
  return 3;
 }
 
 //showing window
 ShowWindow(hwnd, nCmdShow);
 UpdateWindow(hwnd);

 //message loop
 while (GetMessage(&msg, (HWND) NULL, 0, 0)) 
 { 
  DispatchMessage(&msg); 
 } 
 
 ShowCursor(1);
 SystemParametersInfo(SPI_SCREENSAVERRUNNING,0,&dummy,0);

 return msg.wParam;

}

HWND CreateScreenSaverWindow(int width, int height, HWND Parent)
{
 WNDCLASS wc;   //windows class
 HWND hwnd;
 //window class definition
 memset(&wc, 0, sizeof(wc));
 wc.style = CS_PARENTDC;
 wc.lpfnWndProc = WinProc;
 wc.hInstance = hInst;
 //wc.hCursor = LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground = CreateSolidBrush(RGB(0,0,0));
 wc.lpszClassName = MAINCLASS;
 //registering class
 if(!RegisterClass(&wc))
 {
  MessageBox(NULL, "Can't register class!", "Error!", MB_OK|MB_ICONERROR);
  exit(1);
 }
 if(Parent)
 {
  hwnd = CreateWindow(MAINCLASS, "Clock", 
         WS_CHILD|WS_VISIBLE|WS_DISABLED, 0, 0,
         width, height, Parent,
         (HMENU) NULL, hInst, (LPVOID) NULL);
 }
 else
 {
  hwnd = CreateWindow(MAINCLASS, "Clock", 
         WS_VISIBLE|WS_POPUP, 0, 0,
         width, height, 0,
         (HMENU) NULL, hInst, (LPVOID) NULL);
 }
 if(!hwnd)
 {
  MessageBox(NULL, "Can't create window!", "Error!", MB_OK|MB_ICONERROR);
  exit(1);
 }
 return hwnd;
}

LRESULT CALLBACK WinProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
 static movecount=3;
 switch(uMsg)
 {
  case WM_TIMER:
   InvalidateRect(hwnd,NULL,!dbl_buf);
   return 0;
  case WM_SIZE:
   width = LOWORD(lParam);
   height = HIWORD(lParam);
   resized = 1;
   InvalidateRect(hwnd,NULL,!dbl_buf);
   return 0;
  case WM_PAINT:
   Paint(hwnd);
   return 0;
  case WM_MOUSEMOVE:
  case WM_LBUTTONDOWN:
  case WM_MBUTTONDOWN:
  case WM_RBUTTONDOWN:
   if(!preview && (--movecount)<=0)
    PostQuitMessage(0);
   return 0;
  case WM_KEYDOWN:
  case WM_DESTROY:
   PostQuitMessage(0);
   return 0;
  default:
   return DefWindowProc(hwnd,uMsg,wParam,lParam);
 }
}

void Paint(HWND hwnd)
{
 HDC hdc;
 PAINTSTRUCT ps;
 HBRUSH brush;
 RECT rect;
 static HBITMAP bitmap = 0;
 static HDC hdc2 = 0;
 hdc = BeginPaint(hwnd, &ps);
 if(!dbl_buf) //no duble buffering
 {
  DrawClock(hdc, width/2, height/2, height<width?height/2:width/2);
 }
 else //double buffering
 {
  if(resized) //delete old DC and bitmap
  {
   if(bitmap) DeleteObject(bitmap);
   if(hdc2) DeleteDC(hdc2);
  }
  if(!antial) //no antialiasing
  {
   if(resized) //create new DC and bitmap
   {
    hdc2 = CreateCompatibleDC(hdc);
    bitmap = CreateCompatibleBitmap(hdc, width, height);
   }
   SelectObject(hdc2, bitmap);
   brush = CreateSolidBrush(RGB(0,0,0));
   FillRect(hdc2, &ps.rcPaint, brush);
   DrawClock(hdc2, width/2, height/2, height<width?height/2:width/2);
   BitBlt(hdc, 0, 0, width, height, hdc2, 0, 0, SRCCOPY);
  }
  else //antialiasing
  {
   if(resized) //create new DC and bitmap
   {
    hdc2 = CreateCompatibleDC(hdc);
    bitmap = CreateCompatibleBitmap(hdc, width*2, height*2);
   }
   SelectObject(hdc2, bitmap);
   brush = CreateSolidBrush(RGB(0,0,0));
   rect = ps.rcPaint;
   rect.right *= 2;
   rect.bottom *= 2;
   FillRect(hdc2, &rect, brush);
   DrawClock(hdc2, width, height, height<width?height:width);
   SetStretchBltMode(hdc, HALFTONE);
   SetBrushOrgEx(hdc, 0, 0, NULL);
   StretchBlt(hdc, 0, 0, width, height,
              hdc2, 0, 0, width*2, height*2, SRCCOPY);
  }
  DeleteObject(brush);
 }
 EndPaint(hwnd, &ps);
 if(resized)
  resized = 0;
}

void DrawClock(HDC hdc, int x, int y, int radius)
{
 int maxr=radius*CLKRADIUS;
 float hr=maxr*HOURRADIUS;
 float mr=maxr*MINRADIUS;
 float sr=maxr*SECRADIUS;
 float mr1=maxr*MARKRADIUS1;
 float mr2=maxr*MARKRADIUS2;
 static HPEN dbpen, dmpen, dtpen;
 static HPEN bpen, mpen, tpen;
 //define angles
 SYSTEMTIME time;
 GetLocalTime(&time);
 float sang = 2.0*M_PI*(time.wSecond+time.wMilliseconds/1000.0)/60.0;
 float mang = 2.0*M_PI*time.wMinute/60.0+sang/60.0;
 float hang = 2.0*M_PI*(time.wHour%12)/12.0+mang/12.0;
 sang -= M_PI_2; mang -= M_PI_2; hang -= M_PI_2;
 float cos_pi_6 = cos(M_PI_2/3.0);
 float sin_pi_6 = sin(M_PI_2/3.0);
 //dark pens for smoothing
 if(resized)
 {
  DeleteObject(dbpen);
  DeleteObject(dmpen);
  DeleteObject(dtpen);
  dbpen = CreatePen(PS_SOLID, radius*BOLDPEN+2, RGB(127,127,127));
  dmpen = CreatePen(PS_SOLID, radius*MEDIUMPEN+2, RGB(127,102,25));
  dtpen = CreatePen(PS_SOLID, radius*THINPEN+2, RGB(127,127,127));
 }
 //SelectObject(hdc, tpen);
 //Arc(hdc, x-maxr, y-maxr, x+maxr, y+maxr, x, y-maxr, x, y-maxr);
 //big marks
 SelectObject(hdc, dmpen);
 MoveToEx(hdc, x-mr1, y, NULL);
 LineTo(hdc, x-maxr, y);
 MoveToEx(hdc, x+mr1, y, NULL);
 LineTo(hdc, x+maxr, y);
 MoveToEx(hdc, x, y-mr1, NULL);
 LineTo(hdc, x, y-maxr);
 MoveToEx(hdc, x, y+mr1, NULL);
 LineTo(hdc, x, y+maxr);
 //small marks
 SelectObject(hdc, dtpen);
 MoveToEx(hdc, x+mr2*cos_pi_6, y+mr2*sin_pi_6, NULL);
 LineTo(hdc, x+maxr*cos_pi_6, y+maxr*sin_pi_6);
 MoveToEx(hdc, x-mr2*cos_pi_6, y+mr2*sin_pi_6, NULL);
 LineTo(hdc, x-maxr*cos_pi_6, y+maxr*sin_pi_6);
 MoveToEx(hdc, x-mr2*cos_pi_6, y-mr2*sin_pi_6, NULL);
 LineTo(hdc, x-maxr*cos_pi_6, y-maxr*sin_pi_6);
 MoveToEx(hdc, x+mr2*cos_pi_6, y-mr2*sin_pi_6, NULL);
 LineTo(hdc, x+maxr*cos_pi_6, y-maxr*sin_pi_6);
 MoveToEx(hdc, x+mr2*sin_pi_6, y+mr2*cos_pi_6, NULL);
 LineTo(hdc, x+maxr*sin_pi_6, y+maxr*cos_pi_6);
 MoveToEx(hdc, x-mr2*sin_pi_6, y+mr2*cos_pi_6, NULL);
 LineTo(hdc, x-maxr*sin_pi_6, y+maxr*cos_pi_6);
 MoveToEx(hdc, x-mr2*sin_pi_6, y-mr2*cos_pi_6, NULL);
 LineTo(hdc, x-maxr*sin_pi_6, y-maxr*cos_pi_6);
 MoveToEx(hdc, x+mr2*sin_pi_6, y-mr2*cos_pi_6, NULL);
 LineTo(hdc, x+maxr*sin_pi_6, y-maxr*cos_pi_6);
 //hour hand
 SelectObject(hdc, dbpen);
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+hr*cos(hang), y+hr*sin(hang));
 //minute hand
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+mr*cos(mang), y+mr*sin(mang));
 //second hand
 SelectObject(hdc, dtpen);
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+sr*cos(sang), y+sr*sin(sang));
 //normal pens
 if(resized)
 {
  DeleteObject(bpen);
  DeleteObject(mpen);
  DeleteObject(tpen);
  bpen = CreatePen(PS_SOLID, radius*BOLDPEN, RGB(255,255,255));
  mpen = CreatePen(PS_SOLID, radius*MEDIUMPEN, RGB(255,204,051));
  tpen = CreatePen(PS_SOLID, radius*THINPEN, RGB(255,255,255));
 }
 //big marks
 SelectObject(hdc, mpen);
 MoveToEx(hdc, x-mr1, y, NULL);
 LineTo(hdc, x-maxr, y);
 MoveToEx(hdc, x+mr1, y, NULL);
 LineTo(hdc, x+maxr, y);
 MoveToEx(hdc, x, y-mr1, NULL);
 LineTo(hdc, x, y-maxr);
 MoveToEx(hdc, x, y+mr1, NULL);
 LineTo(hdc, x, y+maxr);
 //small marks
 SelectObject(hdc, tpen);
 MoveToEx(hdc, x+mr2*cos_pi_6, y+mr2*sin_pi_6, NULL);
 LineTo(hdc, x+maxr*cos_pi_6, y+maxr*sin_pi_6);
 MoveToEx(hdc, x-mr2*cos_pi_6, y+mr2*sin_pi_6, NULL);
 LineTo(hdc, x-maxr*cos_pi_6, y+maxr*sin_pi_6);
 MoveToEx(hdc, x-mr2*cos_pi_6, y-mr2*sin_pi_6, NULL);
 LineTo(hdc, x-maxr*cos_pi_6, y-maxr*sin_pi_6);
 MoveToEx(hdc, x+mr2*cos_pi_6, y-mr2*sin_pi_6, NULL);
 LineTo(hdc, x+maxr*cos_pi_6, y-maxr*sin_pi_6);
 MoveToEx(hdc, x+mr2*sin_pi_6, y+mr2*cos_pi_6, NULL);
 LineTo(hdc, x+maxr*sin_pi_6, y+maxr*cos_pi_6);
 MoveToEx(hdc, x-mr2*sin_pi_6, y+mr2*cos_pi_6, NULL);
 LineTo(hdc, x-maxr*sin_pi_6, y+maxr*cos_pi_6);
 MoveToEx(hdc, x-mr2*sin_pi_6, y-mr2*cos_pi_6, NULL);
 LineTo(hdc, x-maxr*sin_pi_6, y-maxr*cos_pi_6);
 MoveToEx(hdc, x+mr2*sin_pi_6, y-mr2*cos_pi_6, NULL);
 LineTo(hdc, x+maxr*sin_pi_6, y-maxr*cos_pi_6);
 //hour hand
 SelectObject(hdc, bpen);
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+hr*cos(hang), y+hr*sin(hang));
 //minute hand
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+mr*cos(mang), y+mr*sin(mang));
 //second hand
 SelectObject(hdc, tpen);
 MoveToEx(hdc, x, y, NULL);
 LineTo(hdc, x+sr*cos(sang), y+sr*sin(sang));
}

void parsecommand()
{
 char* cmd=GetCommandLine();
 int i;
 int inquot=0;
 int len=strlen(cmd);
 targv[0]=cmd;
 if(cmd[0]!='\"') targc=1;
 for(i=0;i<len&&targc<30;i++)
 {
  switch(cmd[i])
  {
   case '\"':
    if(inquot)
     cmd[i]=0;
    else
     targv[targc++]=&cmd[i+1];
    inquot=!inquot;
   break;
   case ' ':
    if(!inquot)
    {
     cmd[i]=0;
     if(cmd[i+1]!=' '&&cmd[i+1]!='\"'&&cmd[i+1]!=0)
      targv[targc++]=&cmd[i+1];
    }
   break;
   default:
    targv[targc]=&cmd[i];
  }
 }
}

void Configure()
{
 WNDCLASS wc;   //windows class
 HWND hwnd;
 MSG msg;
 //window class definition
 memset(&wc, 0, sizeof(wc));
 //wc.style = CS_WSPOPUP;
 wc.lpfnWndProc = ConfProc;
 wc.hInstance = hInst;
 wc.hCursor = LoadCursor(NULL, IDC_ARROW);
 wc.hbrBackground = (HBRUSH)(COLOR_BTNFACE+1);
 wc.lpszClassName = CONFCLASS;
 //registering class
 if(!RegisterClass(&wc))
 {
  MessageBox(NULL, "Can't register class!", "Error!", MB_OK|MB_ICONERROR);
  exit(1);
 }
 hwnd = CreateWindow(CONFCLASS, "Clock Quality Setup", 
        WS_OVERLAPPEDWINDOW&(~WS_SIZEBOX)&(~WS_MAXIMIZEBOX)&(~WS_MINIMIZEBOX),
        CW_USEDEFAULT, CW_USEDEFAULT, 
        TRACKWIDTH+BORDWIDTH*2+4, TRACKHEIGHT+TEXTHEIGHT*3+BUTTHEIGHT+BORDWIDTH*6+TITLEHEIGHT+4,
        (HWND) NULL, 
        (HMENU) NULL, hInst, (LPVOID) NULL);
 if(!hwnd)
 {
  MessageBox(NULL, "Can't create window!", "Error!", MB_OK|MB_ICONERROR);
  exit(1);
 }
 ShowWindow(hwnd, SW_SHOW);
 UpdateWindow(hwnd);
 //message loop
 while (GetMessage(&msg, (HWND) NULL, 0, 0)) 
 { 
  TranslateMessage(&msg);
  DispatchMessage(&msg); 
 } 
}

LRESULT CALLBACK ConfProc(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
 static HWND hTrack, hPanel, hText1, hText2, hText3, hButt;
 int Min=0, Max=5, Pos;
 char str[255];
 switch(uMsg)
 {
  case WM_CREATE:
   InitCommonControls();
   hTrack = CreateWindowEx(0, TRACKBAR_CLASS, "Trackbar Control", 
                           WS_CHILD | WS_VISIBLE | TBS_AUTOTICKS | TBS_HORZ,
                           BORDWIDTH, BORDWIDTH, 
                           TRACKWIDTH, TRACKHEIGHT,  
                           hwnd, 
                           ID_TRACKBAR, 
                           hInst,
                           NULL );
   SendMessage(hTrack, TBM_SETRANGE, 
        (WPARAM) TRUE,                 // redraw flag 
        (LPARAM) MAKELONG(Min, Max));  // min. & max. positions
   SendMessage(hTrack, TBM_SETPOS, 
        (WPARAM) TRUE,                  
        (LPARAM) Q);
   sprintf(str,"Update interval %i msec", upd_int);
   hText1 = CreateWindow("STATIC", str, 
                         WS_CHILD|WS_VISIBLE, BORDWIDTH, TRACKHEIGHT+BORDWIDTH*2,
                         TRACKWIDTH, TEXTHEIGHT, hwnd, NULL, hInst, NULL);
   sprintf(str,"Double buffer is %s", dbl_buf?"ON":"OFF");
   hText2 = CreateWindow("STATIC", str, 
                         WS_CHILD|WS_VISIBLE, BORDWIDTH, TRACKHEIGHT+TEXTHEIGHT+BORDWIDTH*3,
                         TRACKWIDTH, TEXTHEIGHT, hwnd, NULL, hInst, NULL);
   sprintf(str,"Antialiasing is %s", antial?"ON":"OFF");
   hText3 = CreateWindow("STATIC", str, 
                         WS_CHILD|WS_VISIBLE, BORDWIDTH, TRACKHEIGHT+TEXTHEIGHT*2+BORDWIDTH*4,
                         TRACKWIDTH, TEXTHEIGHT, hwnd, NULL, hInst, NULL);
   hButt = CreateWindow("BUTTON", "OK", WS_CHILD|WS_VISIBLE|BS_DEFPUSHBUTTON,
                       (TRACKWIDTH-BUTTWIDTH)/2+BORDWIDTH, TRACKHEIGHT+TEXTHEIGHT*3+BORDWIDTH*5,
                       BUTTWIDTH, BUTTHEIGHT, hwnd, (HMENU)ID_BUTT, hInst, NULL);
   SetFocus(hTrack);
   return 0;
  case WM_HSCROLL:
   if((HWND)lParam == hTrack && LOWORD(wParam) == TB_ENDTRACK)
   { 
    Pos = SendMessage(hTrack, TBM_GETPOS, 0, 0);
    GetQual(Pos);
    //sprintf(str,"Track position %i", Pos);
    sprintf(str,"Update interval %i msec", upd_int);
    SetWindowText(hText1, str);
    sprintf(str,"Double buffer is %s", dbl_buf?"ON":"OFF");
    SetWindowText(hText2, str);
    sprintf(str,"Antialiasing is %s", antial?"ON":"OFF");
    SetWindowText(hText3, str);
   }
   return 0;
  case WM_COMMAND:
   if(LOWORD(wParam) == ID_BUTT)
   {
    SaveQual();
    PostQuitMessage(0);
   }
   return 0;
  case WM_DESTROY:
   PostQuitMessage(0);
   return 0;
  default:
   return DefWindowProc(hwnd,uMsg,wParam,lParam);
 }
}

void GetQual(int q)
{
 Q = q;
 upd_int = qual[Q][0];
 dbl_buf = qual[Q][1];
 antial = qual[Q][2];
}

void SaveQual()
{
 HKEY hkey;
 RegCreateKey(HKEY_CURRENT_USER,
              "Software\\Gelin's Soft\\Clock.scr",
              &hkey);
 RegSetValueEx(hkey, "Quality", 0, REG_DWORD, (const unsigned char*)&Q, sizeof(Q));
 RegCloseKey(hkey);
}

void LoadQual()
{
 HKEY hkey;
 unsigned long size, type;
 RegCreateKey(HKEY_CURRENT_USER,
              "Software\\Gelin's Soft\\Clock.scr",
              &hkey);
 RegQueryValueEx(hkey, "Quality", 0, &type, (char*)&Q, &size);
 RegCloseKey(hkey);
 GetQual(Q);
}
